package org.jeecg.modules.sensor.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.sensor.entity.BuGateway;
import org.jeecg.modules.sensor.service.IBuGatewayService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: 网关表
 * @Author: jeecg-boot
 * @Date:   2022-02-18
 * @Version: V1.0
 */
@Api(tags="网关表")
@RestController
@RequestMapping("/sensor/buGateway")
@Slf4j
public class BuGatewayController extends JeecgController<BuGateway, IBuGatewayService> {
	@Autowired
	private IBuGatewayService buGatewayService;
	@Autowired
	private IBuDeviceService buDeviceService;

	/**
	 * 分页列表查询
	 *
	 * @param buGateway
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "网关表-分页列表查询")
	@ApiOperation(value="网关表-分页列表查询", notes="网关表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(BuGateway buGateway,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuGateway> queryWrapper = QueryGenerator.initQueryWrapper(buGateway, req.getParameterMap());
		Page<BuGateway> page = new Page<BuGateway>(pageNo, pageSize);
		IPage<BuGateway> pageList = buGatewayService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param buGateway
	 * @return
	 */
	@AutoLog(value = "网关表-添加")
	@ApiOperation(value="网关表-添加", notes="网关表-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody BuGateway buGateway) {
		BuDevice buDevice = buDeviceService.getById(buGateway.getDeviceId());
		buGateway.setDeviceName(buDevice.getDeviceName());
		buGateway.setOnlineStatus("False");
		buGatewayService.save(buGateway);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param buGateway
	 * @return
	 */
	@AutoLog(value = "网关表-编辑")
	@ApiOperation(value="网关表-编辑", notes="网关表-编辑")
	@PutMapping(value = "/edit")
	public Result<?> edit(@RequestBody BuGateway buGateway) {
		buGatewayService.updateById(buGateway);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "网关表-通过id删除")
	@ApiOperation(value="网关表-通过id删除", notes="网关表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		buGatewayService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "网关表-批量删除")
	@ApiOperation(value="网关表-批量删除", notes="网关表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buGatewayService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "网关表-通过id查询")
	@ApiOperation(value="网关表-通过id查询", notes="网关表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		BuGateway buGateway = buGatewayService.getById(id);
		if(buGateway==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buGateway);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buGateway
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuGateway buGateway) {
        return super.exportXls(request, buGateway, BuGateway.class, "网关表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuGateway.class);
    }

}
